#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include<pthread.h>
#define broj_administracija 4
#define broj_programera 15
#define x 2
typedef struct lista{
    int id;
    int broj_projekata;
    struct lista *sledeci;
}Lista;
pthread_mutex_t mutex1,mutex2;
pthread_cond_t cond1,cond2;
int proces1=0,proces2=0,proces3=0,proces4=0;
Lista *lista=NULL;
int dodaj_na_kraj(Lista **lista,int vr1,int vr2){
    Lista *novi=(Lista*)malloc(sizeof(Lista));
    novi->id=vr1;
    novi->broj_projekata=vr2;
    novi->sledeci=NULL;
    if(*lista==NULL){
        *lista=novi;
        //(*lista)->sledeci=NULL;
        //printf("%d %d\n",vr1,vr2);
    }
    else{
        Lista *pom=*lista;
        while((*lista)->sledeci!=NULL){
            (*lista)=(*lista)->sledeci;
        }
        //printf("%d %d\n",vr1,vr2);
        (*lista)->sledeci=novi;
        //novi->sledeci=NULL;
        //*lista=pom;
    }
}
int dod(Lista **lista,int vr1,int vr2){
    Lista *novi=(Lista*)malloc(sizeof(Lista));
    novi->id=vr1;
    novi->broj_projekata=vr2;
    //novi->sledeci=NULL;
    if(*lista==NULL){
        *lista=novi;
        //(*lista)->sledeci=NULL;
        //printf("%d %d\n",vr1,vr2);
    }
    else{
        Lista *pom=*lista;
        *lista=novi;
        (*lista)->sledeci=pom;
        //printf("%d %d\n",vr1,vr2);
        //pom->sledeci=novi;
        //novi->sledeci=NULL;
        //*lista=pom;
    }
    
}
int bris(Lista **lista,int vr){
    if(*lista==NULL){
        printf("Greska u brisanju\n");
    }
    else{
        Lista *pret=*lista;
        Lista *temp=(*lista)->sledeci;
        if(pret->id==vr){
            *lista=temp;
            pret=temp;
        }
        else{
            while(temp->id!=vr){
                temp=temp->sledeci;
            }
            pret->sledeci=temp->sledeci;
            temp=pret->sledeci;
            
        }
        //*lista=pret;
    }
}
int pretrazi(Lista *lista,int broj){
    //da li postoji vise od x programnera kojin nemaju projekta
    Lista *pom=lista;
    int prebroj=0;
    //1 ako postoji vis eod x a 0 ako ne psootji
    if(lista==NULL){
        return -1;
    }
    while(pom->sledeci!=NULL){
        if(pom->broj_projekata==0){
            prebroj++;
        }
        pom=pom->sledeci;
    
    }
    if(prebroj>=x){
        return 1;
    }
    else return 0;
}
int pretrazi1(Lista **lista,int vrednost1,int vr2){
    //trazi id programera i postavlja mu projekat vr2
    Lista *pom=*lista;
    int ind=0;
    if(*lista==NULL){
        return -1;
    }
    while(pom->sledeci!=NULL){
        if(pom->id==vrednost1){
            pom->broj_projekata=vr2;
            ind=1;
        }
        pom=pom->sledeci;
    }
    *lista=pom;
    if(ind==0){
        return 0;

    }
    else return 1;

}
void * func_provera(void *arg){
    long id=(long)arg;
    sleep(rand()%4);
    //poziva pretrazi koji broji broj programera sa 0 projekata
    pthread_mutex_lock(&mutex1);
    while(proces4==1){
        pthread_cond_wait(&cond1,&mutex1);
    }
    proces1++;
    int odg=pretrazi(lista,x);
    pthread_mutex_unlock(&mutex1);
    //obavljanje 3 sek
    if(odg==1){
        printf("Radnik administracije %ld je pretrazio da u kompaniji postoji vise od %d pogramera bez projekta\n",id,x);
    }
    else if(odg==0){
       printf("Radnik administracije %ld je pretrazio da u kompaniji ne postoji vise od %d pogramera bez projekta\n",id,x);
     
    }
    else{
        printf("LISTA JE PRAZNA\n");
    }
    sleep(3);
    pthread_mutex_lock(&mutex1);
    proces1--;
    pthread_cond_broadcast(&cond1);
    pthread_mutex_unlock(&mutex1);
}
void *func_zaposljavanje(void *arg){
    long id=(long)arg;
    sleep(rand()%4);
    //pozivanje dod 
    pthread_mutex_lock(&mutex1);
    while(proces2==1 || proces4==1){
        pthread_cond_wait(&cond1,&mutex1);
    }
    proces2++;
    dod(&lista,5,0);
    pthread_mutex_unlock(&mutex1);
    //obavljanje 3 sek
    printf("Radnik administracije %ld izvrsava zaposljavanje programera\n",id);
    sleep(3);
    pthread_mutex_lock(&mutex1);
    proces2--;
    pthread_cond_broadcast(&cond1);
    pthread_mutex_unlock(&mutex1);
}
void *func_postavljanje_projekta(void *arg){
    long id=(long)arg;
    sleep(rand()%4);
    //poziva pretrazivanje za odredjenog rpogramera
    pthread_mutex_lock(&mutex1);
    while(proces4==1){
        pthread_cond_wait(&cond1,&mutex1);
    }
    proces3++;
    int odg=pretrazi1(&lista,2,2);
    pthread_mutex_unlock(&mutex1);
    //obavljanje 3 sek
    if(odg==1){
    printf("Radnik administracije %ld je izvvrsio postavljanje projekta programeru uspesno\n",id);
    }
    else if(odg==0){
       printf("Radnik administracije %ld je izvvrsio postavljanje projekta programeru neuspesno\n",id); 
    }
    else{
        printf("GRESKA LISTA JE PRAZNA\n");
    }
    sleep(3);
    pthread_mutex_lock(&mutex1);
    proces3--;
    pthread_cond_broadcast(&cond1);
    pthread_mutex_unlock(&mutex1);
}
void *func_otpustanje(void *arg){
    long id=(long)arg;
    sleep(rand()%4);
    //poziva brisi
    pthread_mutex_lock(&mutex1);
    while(proces1==1 || proces2==1 || proces3==1 || proces4==1){
        pthread_cond_wait(&cond1,&mutex1);
    }
    proces4++;
    bris(&lista,3);
    pthread_mutex_unlock(&mutex1);
    //obavljanje 3 sek
    printf("Radnik administracije %ld izvrsava otpustanje programera\n",id);
    sleep(3);
    pthread_mutex_lock(&mutex1);
    proces4--;
    pthread_cond_broadcast(&cond1);
    pthread_mutex_unlock(&mutex1);
}
int main(){
    pthread_t t1[broj_administracija];
    pthread_mutex_init(&mutex1,NULL);
    pthread_cond_init(&cond1,NULL);
    //lista=malloc(sizeof(Lista));
    //lista=NULL;
    dodaj_na_kraj(&lista,1,0);
    dodaj_na_kraj(&lista,2,0);
    dodaj_na_kraj(&lista,3,0);
    dodaj_na_kraj(&lista,4,0);
    for(long i=0;i<broj_administracija;i++){
        if(i%4==0){
            pthread_create(t1+i,NULL,func_provera,(void*)i);
        }
        else if(i%4==1){
            pthread_create(t1+i,NULL,func_zaposljavanje,(void*)i);
        }
        else if(i%4==2){
            pthread_create(t1+i,NULL,func_postavljanje_projekta,(void*)i);
        }
        else{
            pthread_create(t1+i,NULL,func_otpustanje,(void*)i);
        }
    }
    
    for(long i=0;i<broj_administracija;i++){
        pthread_join(t1[i],NULL);
    }
    
    return 0;
}