#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

#define BR_ZAPOSLENIH 4
#define BR_PROJEKATA 3
#define BR_PROGRAMERA 5
#define X 3

pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

int I = 0, D = 0, S = 0, izmena = 0;

int id_novi = 0;
int ID, P;
int projekat_novi;

typedef struct lista_zaposlenih
{
	int id;
	int br_projekta;
	struct Zaposleni *sledeci;
}Zaposleni;

Zaposleni *z = NULL;

int pretraziBezProjekta()
{
	Zaposleni *pom;
	int br = 0;

	pom = z;
	
	while(pom->sledeci != NULL)
		{
			if(pom->br_projekta == 0)
				br++;
			pom = pom->sledeci;
		}
		
	return br;
}

void pretraziIIzmeni()
{
	Zaposleni *pom;

	pom = z;
	
	while(pom->sledeci != NULL)
		{
			if(pom->id = ID)
				{
					pom->br_projekta = P;
					break;
				}
			else
			pom = pom->sledeci;
		}
}

void unesi()
{
	Zaposleni *novi;
	novi = (Zaposleni*)malloc(sizeof(Zaposleni));
	novi->id = id_novi;
	novi->br_projekta = 0;
	novi->sledeci = NULL;

	if(z == NULL)
		z = novi;
	else
	{
		novi->sledeci = z;
		z = novi;
	}
	
}

void obrisi()
{
	Zaposleni *pom, *preth;

	pom = z;
	preth = z;

	while(pom->sledeci != NULL)
		{
			if(pom->id = ID)
			{
				preth = pom->sledeci;
				free(pom);
				break;
			}
			else {
				preth = pom;
				pom = pom->sledeci;
			}
		}
		
}

void *Proveri(void *arg)
{
	long id = (long)arg;
	
	int br;

	pthread_mutex_lock(&mutex);

	while(D > 0 || izmena > 0)
		pthread_cond_wait(&cond, &mutex);
	
	S++;	
	
	pthread_mutex_unlock(&mutex);
	
	printf("zadatak B X: Zaposleni &ld pretrazuje \n", id);
	br = pretraziBezProjekta();
	sleep(1);

	pthread_mutex_lock(&mutex);
	
	S--;
	if(S == 0)	
		pthread_cond_broadcast(&cond);		

	pthread_mutex_unlock(&mutex);

	if(br >= X)
		printf("zadatak B X: Zaposleni &ld je zavrsio sa pretragom ima vise od X programera bez projekta, br: %d \n", id, br);
	else
		printf("zadatak B X: Zaposleni &ld je zavrsio sa pretragom ima manje od X programera bez projekta, br: %d \n", id, br);

}


void *Zaposli(void *arg)
{
	long id = (long)arg;	
	id_novi++;	

	pthread_mutex_lock(&mutex);

	while(D > 0 || I > 0 || izmena > 0)
		pthread_cond_wait(&cond, &mutex);
	
	I++;	
	
	pthread_mutex_unlock(&mutex);
	
	printf("zadatak Z: Zaposleni &ld zaposljava novog programera, id: %d \n", id, id_novi);
	unesi();
	sleep(1);
	
	pthread_mutex_lock(&mutex);

	printf("zadatak Z: Zaposleni &ld je zavrsio sa zaposljavanjem novog programera, id: %d \n", id, id_novi);	
	
	I--;
	if(I == 0)	
		pthread_cond_broadcast(&cond);		

	pthread_mutex_unlock(&mutex);
}

void *PostaviNaProjekat(void *arg)
{

	long id = (long)arg;	
	
	ID = rand() % BR_PROGRAMERA;
	P = rand() % BR_PROJEKATA;

	pthread_mutex_lock(&mutex);

	while(D > 0 || I > 0 || S > 0 || izmena > 0)
		pthread_cond_wait(&cond, &mutex);
	
	izmena++;	
	
	pthread_mutex_unlock(&mutex);
	
	printf("Zadatak D ID P: Zaposleni &ld postavlja programera %d na projekat %d \n", id, ID, P);
	pretraziIIzmeni();
	sleep(1);	

	pthread_mutex_lock(&mutex);
	
	izmena--;
	if(izmena == 0)	
		pthread_cond_broadcast(&cond);		
	
		printf("Zadatak D ID P: Zaposleni &ld zavrsava postavljenje programera %d na projekat %d \n", id, ID, P);
	pthread_mutex_unlock(&mutex);

}
void *Otpusti(void *arg)
{
	long id = (long)arg;	
	ID = rand() % BR_PROGRAMERA;

	pthread_mutex_lock(&mutex);

	while(D > 0 || I > 0 || S > 0 || izmena > 0)
		pthread_cond_wait(&cond, &mutex);
	
	D++;	
	
	pthread_mutex_unlock(&mutex);
	
	printf("Zadatak O D: Zaposleni &ld brise iz liste programera %d \n", id, ID);
	obrisi();
	sleep(1);
	
	pthread_mutex_lock(&mutex);
	
	D--;
	if(D == 0)	
		pthread_cond_broadcast(&cond);		
	
	pthread_mutex_unlock(&mutex);
}

int main()
{
	
	pthread_t threads[BR_ZAPOSLENIH];/*
	
	for(long i = 0; i < BR_ZAPOSLENIH; i++) {
		if(i % 4 == 0)
			pthread_create(threads + i, NULL, Proveri, (void*)i);
		else if(i % 4 == 1)
			pthread_create(threads + i, NULL, Zaposli, (void*)i);
		else if(i % 4 == 2)
			pthread_create(threads + i, NULL, PostaviNaProjekat, (void*)i);
		else if(i % 4 == 3)
			pthread_create(threads + i, NULL, Otpusti, (void*)i);
	}*/
	
	pthread_create(threads[0], NULL, Proveri, (void*)i); // B X
	pthread_create(threads[1], NULL, Zaposli, (void*)i); // Z
	pthread_create(threads[2], NULL, PostaviNaProjekat, (void*)i); //D ID P
	pthread_create(threads[3], NULL, Otpusti, (void*)i); // O ID

}
